--[[ macro should be: /run MillButtonSetup() /click MillButton ]]

local _, L = ...;
local mill = CreateFrame("CheckButton","MillButton",UIParent,"SecureActionButtonTemplate")
mill:SetAttribute("type","macro")
	
local function findherb()
  local function f(b,s)
    if GetContainerItemLink(b,s) then
	local itemName,_,_,_,_,_,itemType = GetItemInfo(GetContainerItemLink(b,s))
		--********************
		--For translations only. 
		--print(GetLocale()) --Shows current game language
		--print(itemType) --Shows localized ItemType in mainchatframe.
		--********************
		for n=1,7 do -- repeat 7 times for each ignorestring
			if itemName==(L["ignore_"..n]) then
				--********************
				--For debugging only.
				--print(L["ignore_"..n] skipped)
				--********************
				return
			end
		end
		return (itemType==(L["item_type"]) or itemName==(L["item_name"])) and select(2,GetContainerItemInfo(b,s))>=5
	end
  end
  for i=0,4 do
    for j=1,GetContainerNumSlots(i) do
      if f(i,j) then
        return i,j
      end
    end
  end
end  

function MillButtonSetup()
  local b,s = findherb()
  if (not b or not s) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
    -- do nothing if no herb, if looting or casting
    MillButton:SetAttribute("macrotext","")
    if not b then
		--print(L["error"])
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
	end
  else
	MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..L["macro_spell"].."\n/"..L["macro_use"].." "..b.." "..s)
  end
end